Subject: Re: bug#52994: 29.0.50; Help descriptions from menu bar items don't appear in the echo area

From: Po Lu <[email-masked]>
Date: Sat, 22 Jan 2022 21:50:04 +0800

Po Lu <[email-masked]> writes:

>> What's the "menu bar" if not the toolkit menus?

> On every other toolkit (and at least GNUstep, which I just verified),
> the menu bar doesn't interfere with the usual event loop.  Though
> unfortunately GNUstep doesn't implement willHighlightItem, so I can only
> implement help text for macOS.

Unfortunately, it seems that's not possible either: macOS itself runs a
nested event loop inside HIToolBoxTrackMenuCommon whenever the menu bar
is opened, which seems to involve Carbon.  I don't know anything about
Carbon, so someone else will have to figure out how to exit such an
event loop.

Otherwise, the code works fine, so I installed it for GNUstep (where
menu tracking is done in the NS event loop) in the hopes that they will
implement `willHighlightItem' at some point in the future.

Thanks.